/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : AtMega8   
Version : 1.0
Date    : 24.02.2024
Author  :  ..
Company : Home
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 4,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256

Temp_ust =4   ,   -2  " " ,  =  " "
 -5  Temp_ust   SMS. 

*******************************************************/
#include <mega8.h>
#include <delay.h>                                          // 
#include <ds18b20.h>                                        //     ds18b20


// Declare your global variables here
#define MAX_DS18B20 8
float temp1;// ,temp2;                                      //     
unsigned char devices=0;                                    //      DS18b20
unsigned char rom_code[2][9];                               //      [4][9] 4 .
unsigned int A,B,C,D=0;
unsigned char At,Bt,Ct, Dt=0; 
//int Ct1 = 0;
int znak = 0;                                               //    
unsigned int Bt1 = 0;

#define Start_Pause 60                                      //   (  ) 60 
#define interval 50                                         //       Sim800L ( UART)
#define _Tel_OFF 300
#define RX_BUFFER_SIZE 150
#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)
#define _tim_end 60                                         //   ds18b20   
#define _timer_perep 61628
#asm
   .equ __w1_port=0x12 ;PORTD                               //   
   .equ __w1_bit=6 
#endasm

int Temp_ust1 =4;                                           //   -5 .   (  ),      -2 .
int Temp_ust2 =30;                                          //   +30 .(  )
int Temperat = 0;                                           // .   .   

unsigned char i, rx_cursor;                                 //  ()   
char MyBuffer[RX_BUFFER_SIZE];                              //    SMS    
unsigned int z;                                             //    
flash unsigned char cmd_0[]={"AT+IPR=9600"};                //    UART
flash unsigned char cmd_1[]={"AT"};                         //        ( 0)
flash unsigned char cmd_2_0[]={"AT+CSCS=\"UCS2\""};         //  SMS "UCS2"  
flash unsigned char cmd_2_1[]={"AT+CMGF=0"};                //  PUD  (  )
flash unsigned char cmd_2_2[]={"AT+CMGS="};                 // -    (   ) PUD SMS
flash unsigned char cmd_3[]={"0001000B91"};                 //  PUD SMS 
flash unsigned char cmd_4[]={"ATH0"};                       //   ( )
flash unsigned char cmd_5_1[]={""};                  //  
flash unsigned char cmd_5_2[]={""};                    //  
flash unsigned char cmd_6[]={"."};                 //  
flash unsigned char cmd_7_1[]={"."};              //  
flash unsigned char cmd_7_2[]={"."};               //  
flash unsigned char cmd_7_3[]={"."};            //  
flash unsigned char cmd_7_4[]={"."};             //  
flash unsigned char cmd_7_5[]={"."};               //  
flash unsigned char cmd_9[]={"AT+CLIP=1"};                  //     - 
flash unsigned char cmd_10[]={"ATD+ "};                     //    "ATD+ +7xxxxxxxxxx;"  
flash unsigned char cmd_11[]={" "};            //   " ."
flash unsigned char cmd_12[]={" "};               //   " "
flash unsigned char cmd_14[]={"Tem "};                      //      "Tem -1"
unsigned char cmd_8[]={"+79123456789"};//[13]               //    
unsigned char _flag = 0;                                    //    
unsigned char _flag_D = 0;                                  //   SMS  
int _Tel = 0;                                               //      (  )
int Ring = 0;                                               //    = 4
int Deact = 0;                                              //     -   "DEACT"  Deact==5    GPS 
int _tim  = 0;                                              //    ds18b20
int _tim1  = 0;                                             //    
int siren = 0;                                              // 1=   0= 
unsigned char SMS_dlinna=0;                                 //  TXT   PUD SMS  (     140 )
unsigned char SMS_zag[28];                                  //     PUD SMS 
unsigned char SMS_text[280];                                //    TXT  PUD SMS 
__eeprom unsigned char cmd_8e[]={"+79123456789"};           //    EEProm
//=======================================================================
// Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Place your code here
_tim++;
_tim1++;
TCNT1 = _timer_perep;
}
//------------------------------------------
// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
    { 
    char status, data;
    status=UCSRA;
    data=UDR;
    if ((status & (FRAMING_ERROR | PARITY_ERROR )) ==0)     
      {                                                 

        }
      if (Ring!=4)
        {
        if (data=='R') Ring=1;
        if (data=='I') 
            {
            if (Ring==1) Ring++;
            else  Ring=0;
            }            
        if (data=='N')
            {
            if (Ring==2) Ring++;
            else  Ring=0;
            }
        if (data=='G')
            {
            if (Ring==3) Ring++;                            // Ring = 4   
            else  Ring=0;
            }
        }
      if (Deact!=5)
        {
        if (data=='D') Deact=1;                             //     -   "DEACT"  
        if (data=='E')                                      //  Deact==5    GPS 
            {
            if (Deact==1) Deact++;
            else  Deact=0;
            }        
        if (data=='A') 
            {
            if (Deact==2) Deact++;
            else  Deact=0;
            }        
        if (data=='C') 
            {
            if (Deact==3) Deact++;
            else  Deact=0;
            } 
        if (data=='T') 
            {
            if (Deact==4) Deact++;
            else  Deact=0;
            }       

        if((data==0x0d)||(data==0x0a))
            {
            if(i>0)
                {
                data = 0;
                }
            }
        MyBuffer[i]=data;
        i ++;                                               //                                        
        if (i == RX_BUFFER_SIZE)                            //     
            {                                               //     
            i=0;                                            //   = 0
            }
        
      }
    }  
//-----------------------------------------------------------------
// Analog Comparator interrupt service routine
//-----------------------------------------------------------------
//interrupt [ANA_COMP] void ana_comp_isr(void)
//{
// Place your code here
//if (PIND.4==0) 
//Temperat = 1;                                             //  D4 = Gnd   -4 1   DS18b20 
//}
//=================================================================
//-----------------------------------------------------------------
//     SMS
void chislo( int cislo)                                     //                                                 
    {                                                       //  -  D C B A 
    A = B = C  = cislo;
    C = C / 100 ;                                           //    (  100)
    B = A = B % 100 ;                                       //     100
    B = B / 10 ;                                            //    (  10)  
    A = A % 10 ;                                            //     (     10)
 
    if (znak>0) D=0x2d;
    else D = '+';
    if (C==0)                                               //       (  )   
        { 
        C=D;
        D=0x20;
        }                           

    Dt=D;
    if (C<10) Ct=C|0x30;
    else Ct=C;
    Bt=B|0x30;
    At=A|0x30;  
    }
//-------------------------------------------------------------
//-------------    DS18b20 --------------
//-------------------------------------------------------------
void _Temper(void)                                          //      
    { 

    if (devices==0)
        {
        devices=w1_search(DS18B20_SEARCH_ROM_CMD,rom_code); //        1-Wire 
        ds18b20_init(0,-35,35,DS18B20_12BIT_RES);           //    12  
        delay_ms(500);
        }
    else {
        temp1 = ds18b20_temperature(&rom_code[0][0]);       //     
        if ((temp1 < 100) & (temp1 > -60))                  //    
            { 
            if (temp1>0)znak=0;                             //    - (   znak=1)
            else znak=1;                                                                                                    
            if (temp1<(Temp_ust1-2)) PORTB.5 = 1;           //   
            if (temp1>Temp_ust1) PORTB.5 = 0;               //   
            if (temp1<(Temp_ust1-5)) Temperat = 1;          //  D4 = 1  DS18b20       
            else
                {
                if (temp1>Temp_ust2) Temperat = 2;          //  D4 = 1  DS18b20           
                else Temperat = 0;
                }
                        temp1=temp1*10;                     //   (             
            if (znak==1) 
                {
                temp1 = -temp1;                             //         
                }
            Bt1 = (int) temp1;         
            chislo(Bt1);                                    //        
            } 
        } 
    }
//-----------------------------------------------------------------
//-------       ----------
//-----------------------------------------------------------------
int AON_(void)                                      
    { char y, x =0; 
    rx_cursor = 0;                                          //   (    UART)
    delay_ms(1000);                                         //       
    x = i;                          
    #asm("cli")                                             //  
    i = 0;                                                  //   UART 
    #asm("sei")                                             //      
    if (x==0) return 0;                                     //   -   
    y=0;   

    for ( rx_cursor=0;rx_cursor!=x;rx_cursor++)                                                                             
        {
        if (y==12) return 1;                                //       
        if (rx_cursor==RX_BUFFER_SIZE) return 0;            //   -  
        if (cmd_8[y]==MyBuffer[rx_cursor])
            {
            y++;
            }
        }
    if (y<12) return 0;                                     //    (   )
    }
//-----------------------------------------------------------------
//------------   ( ) --------------------
//-----------------------------------------------------------------
void Otboy(void)                                    
    {

    for(z=0;cmd_4[z]!='';z++)                               //  
        {
        UDR = cmd_4[z];
        delay_ms(100);
        }
    UDR = ('\r');
    delay_ms(1500);    
    } 
//----------------------------------------------------------
//-------------   GSM Sim800L --------------
//----------------------------------------------------------
void _Start_telef(void)
    { int i; 
//   
PORTD.2 = 0;                                                //   GSM Sim800L                            
for (i=0;i<2;i++)                            
    {                                                       // 1   Reset = 0
    PORTB.0 = 1;
    delay_ms (100);
    PORTB.1 = 1;
    delay_ms (100);
    PORTB.2 = 1;
    delay_ms (100);
    PORTB.3 = 1; 
    delay_ms (100);
    PORTB.4 = 1;
    delay_ms (100);
    PORTC.5 = 1;
    delay_ms (100);
    PORTC.5 = 0;
    delay_ms (100);
    PORTB.4 = 0;
    delay_ms (100);
    PORTB.3 = 0;
    delay_ms (100);
    PORTB.2 = 0;
    delay_ms (100);
    PORTB.1 = 0;
    delay_ms (100);
    PORTB.0 = 0;
    delay_ms (100);
    }
PORTD.2 = 1;                                                //  Reset  GSM   Res = 1
for (i=0;i<Start_Pause*2;i++)
    {                                                       //=120  60    
    PORTB.0 = 1;
    delay_ms (100);
    PORTB.0 = 0;
    PORTB.1 = 1;
    delay_ms (100);
    PORTB.1 = 0;
    PORTB.2 = 1;
    delay_ms (100);
    PORTB.2 = 0;
    PORTB.3 = 1;
    delay_ms (100);
    PORTB.3 = 0;
    PORTB.4 = 1;
    delay_ms (100);
    PORTB.4 = 0;
    PORTC.5 = 1;
    delay_ms (100);
    PORTC.5 = 0;
    }
    PORTD.5 = 1;                                            //    SMS  
    for(z=0;cmd_1[z]!='';z++)                               //     
        {
        UDR = cmd_1[z];
        delay_ms(100);
        }
    UDR = ('\r');
    delay_ms(500);
    for(z=0;cmd_0[z]!='';z++)                               //    UART
        {
        UDR = cmd_0[z];
        delay_ms(100);
        }
    UDR = ('\r');
    delay_ms(500);
    for(z=0;cmd_9[z]!='';z++)                               //     - 
        {
        UDR = cmd_9[z];
        delay_ms(100);
        }
    UDR = ('\r');        
    delay_ms(500); 
    PORTD.5 = 0;                                            //    SMS  
    }
//------------------------------------------------------------
//--------------- --------------------------------
//------------------------------------------------------------
void  bait_seg( unsigned int u0)
    { unsigned char u1,u2,u3,u4=0;
    

            u3 = u4 = u0;                                   //    UNICOD  4  ( 0x043C = 0 4 3  )
            u4 = u4 & 0x0F;
            if (u4>9)
                {
                if (u4==0x0A) u4 = 'A';
                if (u4==0x0B) u4 = 'B';
                if (u4==0x0C) u4 = 'C';
                if (u4==0x0D) u4 = 'D';
                if (u4==0x0E) u4 = 'E';
                if (u4==0x0F) u4 = 'F';
                }
            else u4 = u4 + 0x30; 
            
            u3 = u3 & 0xF0; 
            u3 = u3 >> 4;
            if (u3>9)
                {
                if (u3==0x0A) u3 = 'A';
                if (u3==0x0B) u3 = 'B';
                if (u3==0x0C) u3 = 'C';
                if (u3==0x0D) u3 = 'D';
                if (u3==0x0E) u3 = 'E';
                if (u3==0x0F) u3 = 'F';
                }    
            else u3 = u3 + 0x30;
            
            u0 = u0 & 0xFF00;
            u0 = u0 >> 8;
            u1 = u2 = u0;
            u2 = u2 & 0x0F;
            if (u2>9)
                {
                if (u2==0x0A) u2 = 'A';
                if (u2==0x0B) u2 = 'B';
                if (u2==0x0C) u2 = 'C';
                if (u2==0x0D) u2 = 'D';
                if (u2==0x0E) u2 = 'E';
                if (u2==0x0F) u2 = 'F';
                }              
            else u2 = u2 + 0x30;
            u1 = u1 & 0xF0;
            u1 = u1 >> 4;
            if (u1>9)
                {
                if (u1==0x0A) u1 = 'A';
                if (u1==0x0B) u1 = 'B';
                if (u1==0x0C) u1 = 'C';
                if (u1==0x0D) u1 = 'D';
                if (u1==0x0E) u1 = 'E';
                if (u1==0x0F) u1 = 'F';
                }
            else u1 = u1 + 0x30;
            if (SMS_dlinna<140-3) 
                {                                           //   4    PDU SMS ,   
                SMS_text[SMS_dlinna] = u1; 
                SMS_dlinna++;
                SMS_text[SMS_dlinna] = u2;
                SMS_dlinna++;
                SMS_text[SMS_dlinna] = u3; 
                SMS_dlinna++;
                SMS_text[SMS_dlinna] = u4;
                SMS_dlinna++;
                }             
    }
//-------------------------------------------------------------                                                                    
//-------------  PUD   SMS -------------                                                           
//-------------------------------------------------------------
void sms_PDU_text (void)                                    //    SMS
    { unsigned int u0=0;
    SMS_dlinna = 0;
//-----------  SMS -----------------------        // = 140 -       70 
    if (_flag_D&0x40)                                       // SMS - "Zvonok"   ,   
      if ((_flag_D!=0x90)&&(_flag_D!=0x91))
        {
        for(z=0;cmd_6[z]!='';z++)                           //   SMS rus
           {
            u0 = cmd_6[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD             
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
           }
        bait_seg(0x000D);
        } 
//------------------------------------
    if (_flag_D&0x80)                                       // SMS - "Temper Holod"   ,                                    
      if ((_flag_D!=0x90)&&(_flag_D!=0x91))
        {
        for(z=0;cmd_5_1[z]!='';z++)                         //   SMS
           {
            u0 = cmd_5_1[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD             
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
           }
        bait_seg(0x000D);
        } 
//------------------------------------
    if (_flag_D&0x20)                                       // SMS - "Temper Jarko"   ,                                      
      if ((_flag_D!=0x90)&&(_flag_D!=0x91))
        {
        for(z=0;cmd_5_2[z]!='';z++)                         //   SMS
           {
            u0 = cmd_5_2[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD             
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
           }
        bait_seg(0x000D);
        } 
//------------------------------------
    if (_flag_D&0x01)                                       // SMS - "Dver"    ,       
      if ((_flag_D!=0x90)&&(_flag_D!=0x91))
        {                                                                                       
        for(z=0;cmd_7_1[z]!='';z++)                         //   SMS
           {
            u0 = cmd_7_1[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD             
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
           }
        bait_seg(0x000D);
        } 
//------------------------------------
    if (_flag_D&0x02)                                       // SMS - "Vorota"    ,    
      if ((_flag_D!=0x90)&&(_flag_D!=0x91))
        {                                                                                        
        for(z=0;cmd_7_2[z]!='';z++)                         //   SMS
           {
            u0 = cmd_7_2[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD             
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
           }
        bait_seg(0x000D);
        } 
//------------------------------------
    if (_flag_D&0x04)                                       // SMS - ""    ,   
        {                                                                              
      if ((_flag_D!=0x90)&&(_flag_D!=0x91))
        for(z=0;cmd_7_3[z]!='';z++)                         //   SMS
           {
            u0 = cmd_7_3[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD             
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
           }
        bait_seg(0x000D);   
        } 
//------------------------------------
    if (_flag_D&0x08)                                       // SMS - ""     ,    
        {                                                                                 
      if ((_flag_D!=0x90)&&(_flag_D!=0x91))
        for(z=0;cmd_7_4[z]!='';z++)                         //   SMS
           {
            u0 = cmd_7_4[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD             
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
           }
        bait_seg(0x000D);
        } 
//---------------------------------
    if (_flag_D&0x10)                                       // SMS - "Pojar"     ,    
      {
      if ((_flag_D!=0x90)&&(_flag_D!=0x91))                                                                                     
        for(z=0;cmd_7_5[z]!='';z++)                         //   SMS
           {
            u0 = cmd_7_5[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD             
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
           }
        bait_seg(0x000D);
      }
//----------------------------------
    if (_flag_D == 0x90)                                      //SMS - "Clear Tel"       ,    
        {                                                
        for(z=0;cmd_11[z]!='';z++)                          //   SMS
            {
            u0 = cmd_11[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD              
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
            }
        bait_seg(0x000D);        
        } 
//----------------------------------
    if (_flag_D == 0x91)                                      // SMS - "New Tel"                  ,    
        {                                         
        for(z=0;cmd_12[z]!='';z++)                          //   SMS
            {
            u0 = cmd_12[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD             
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
            }
        bait_seg(0x000D); 
        }
    
//----------------------------------        
    for(z=0;cmd_14[z]!='';z++)                              //   SMS   " Tem "
            {
            u0 = cmd_14[z];
            if (u0>0x7F) 
                {
                u0 = u0 + 0x0350;                           //     UNICOD               
                }
            else u0 = u0 & 0x00FF;
            bait_seg(u0);
            } 
    bait_seg(Dt);
    bait_seg(Ct);
    bait_seg(Bt);        
    bait_seg(',');
    bait_seg(At); 
    bait_seg('"');
    bait_seg('C'); 
    } 
//-------------------------------------------------------------
//-------------   PDU SMS --------------------                                                           
//-------------------------------------------------------------
void sms_zagolovok (void)  
    {  unsigned char u2,u3=0; unsigned char e1=0;
                                 
    for(z=0;z<10;z++)                                       //   PDU SMS 
        { 
        u2 = cmd_3[z];
        SMS_zag[e1] = u2;
        e1++;
        }                                                                         
    for(z=1;z<12;z++)                                       //     PDU SMS 
        {                                                   //               F
        u3 = cmd_8[z];                                      //  +79113091234  97h 11h 03h 19h 32h F4h
        z++;
        u2 = cmd_8[z];

        if (z==12) u2 = 'F';
        SMS_zag[e1] = u2;
        e1++;
        SMS_zag[e1] = u3;
        e1++;
        }           
        SMS_zag[e1] = '0';
        e1++;
        SMS_zag[e1] = '0';
        e1++;
        SMS_zag[e1] = '0';
        e1++;
        SMS_zag[e1] = '8';                                  //   PDU SMS
        e1++;
         
        u2 = u3 = SMS_dlinna /2;                            //-   SMS  (  2 )    2

        u3 = u3 & 0x0F; 
        if (u3>9)
            {
            if (u3==0x0A) u3 = 'A';
            if (u3==0x0B) u3 = 'B';
            if (u3==0x0C) u3 = 'C';
            if (u3==0x0D) u3 = 'D';
            if (u3==0x0E) u3 = 'E';
            if (u3==0x0F) u3 = 'F';
            }    
        else u3 = u3 + 0x30;
        
        u2 = u2 & 0xF0;    
        u2 = u2 >> 4;
        if (u2>9)
            {
            if (u2==0x0A) u2 = 'A';
            if (u2==0x0B) u2 = 'B';
            if (u2==0x0C) u2 = 'C';
            if (u2==0x0D) u2 = 'D';
            if (u2==0x0E) u2 = 'E';
            if (u2==0x0F) u2 = 'F';
            }
        else u2 = u2 + 0x30;
               
        SMS_zag[e1] = u2;
        e1++;
        SMS_zag[e1] = u3; 

    }   
//-------------------------------------------------------------
//------------- SMS------------------------------------                                                           
//-------------------------------------------------------------
void sms_out (void)                                         //  SMS
    { unsigned char y1, y2,y3=0; 

    PORTD.5 = 1;                                            //   SMS
    _Temper();                                              //       ( )
    
    sms_PDU_text();                                         //    SMS     
    sms_zagolovok();                                        //   PDU SMS  (   )
    
    for(z=0;cmd_1[z]!='';z++)                               //      "AT"
        {
        UDR = cmd_1[z];
        delay_ms(interval);
        }
    UDR = ('\r');                                           //   ()
    delay_ms(500);

    for(z=0;cmd_2_1[z]!='';z++)                             //  SMS PDU      "AT+CMGF=0"
        {
        UDR = cmd_2_1[z];
        delay_ms(interval);
        }
    UDR = ('\r');                                           //   ()
    delay_ms(500);
    for(z=0;cmd_2_0[z]!='';z++)                             //  SMS PDU   " AT+CSCS="UCS2" "
        {
        UDR = cmd_2_0[z];
        delay_ms(interval);
        }
    UDR = ('\r');                                           //   ()
    delay_ms(500);
        

    for(z=0;cmd_2_2[z]!='';z++)                             //    SMS PDU   
        {
        UDR = cmd_2_2[z];
        delay_ms(interval);
        } 
        
    y1 = y3 = y2  = (SMS_dlinna + 26)/2;                    //  PDU   +  ,     
    y1 = y1 / 100;                                          //   2 (  2 )
    y2 = y3 = y2 % 100;
    y2 = y2 / 10 ;                                          //   (  10)  
    y3 = y3 % 10 ;                                          //   (    10)
    if (y1!=0) 
        {
        y1 = y1 + 0x30;
        UDR = y1;                                           //       (2   3)
        delay_ms(interval); 
        }
    y2 = y2 + 0x30;
    y3 = y3 + 0x30;

    UDR = y2;                                               //       (2 )
    delay_ms(interval);   
    UDR = y3;     
    delay_ms(interval);
    UDR = ('\r');                                           //   ()
//-----------------------
    delay_ms(1500);                                         //      SMS ( )
//-----------------------
    for (z=0;z<28;z++)                                      //   PDU SMS  
        {
        UDR = SMS_zag[z];
        delay_ms(interval);
        }
    delay_ms(interval);
    for (y1=0;y1<SMS_dlinna;y1++)                           //   PDU SMS  
        {    
        UDR = SMS_text[y1];
        delay_ms(interval); 
        }

    UDR = (26);                                             // ctrlZ->      0x1A
    delay_ms(1500);  

    //if (_flag==1)    PORTD.5 = 1;                           //     SMS     
    //else 
    PORTD.5 = 0;
    }
//-------------------------------------------------------------
//-------------  -------------------------------
//-------------------------------------------------------------
void Zvonok(void)
    {  int r; 
    PORTD.5 = 1;                                            //   SMS
    for(z=0;cmd_1[z]!='';z++)                               //     
        {
        UDR = cmd_1[z];
        delay_ms(100);
        }
    UDR = ('\r');                                           //   ()
    delay_ms(500);

    for(z=0;cmd_10[z]!='';z++)                              //     
        {
        UDR = cmd_10[z];
        delay_ms(100);
        }

    for(z=0;cmd_8[z]!='';z++)                               //   
        {
        UDR = cmd_8[z];
        delay_ms(100);
        }
    UDR = (';');
    delay_ms(100);
    UDR = ('\r');                                           //   ()
    delay_ms(1000);                                         //   ( )

    for (r=0;r<100;r++) 
        {
        delay_ms (150);                                     //   15   
        }
        Otboy();                                                //   (  )
    PORTD.5 = 0;                                            //    SMS   
    }
//-------------------------------------------------------------------------------------
//----     ---------------------------------------------
//-------------------------------------------------------------------------------------
void Priviazka_tel(void)                                    //         ""  
    {  char Ring2, y, x =0; 
    if (cmd_8e[0]=='+')                                     //     (    +)   SMS      
        {
        _flag_D = 0x90;                                       //  SMS "Clear Tel"
        sms_out();                                          //  SMS    
        //cmd_8[0]=cmd_8e[0]=0;                               //  +    (  )      
        } 
    cmd_8[0]=cmd_8e[0]=0;                               //  +    (  )
    PORTD.5 = 1;
    PORTB=(0<<PORTC5) | (1<<PORTC4) | (1<<PORTC3) | (1<<PORTC2) | (1<<PORTC1) | (1<<PORTC0);
    PORTC.5 = 1;                                            // Led    
    //if (Ring==4)                                            //                                                         
    for (;Ring<4;) #asm("wdr");                                             //   
        { 
        PORTB.0 = 0;                                        // Led    
        PORTC.5 = 0;
        delay_ms (interval); 
        Ring=0;                                             //     
        Otboy();                                            //   
        if (i==0) return;                                   //     -    
        x=i;
        #asm("cli")                                         //  
        i = 0;                                              //   UART   

        for ( rx_cursor=0;rx_cursor!=x;rx_cursor++)
            { 
            PORTB.1 = 0;
            PORTB.4 = 0;
            y = MyBuffer[rx_cursor];
            if (y=='R') Ring2=1;
            if (y=='I') 
                {
                if (Ring2==1) Ring2++;
                else  Ring2=0;
                }            
            if (y=='N')
                {
                if (Ring2==2) Ring2++;
                else  Ring2=0;
                }
            if (y=='G')
                {
                if (Ring2==3) Ring2++;                      // Ring = 4   
                else  Ring2=0;
                }
            if (Ring2==4)
                { 
                rx_cursor=rx_cursor+13;                     //  RING   13     
                for (z=0;z<13;z++)                  
                    {
                    cmd_8[z] = cmd_8e[z] = MyBuffer[rx_cursor]; //       EEProm   
                    rx_cursor++;
                    if (z==12) 
                        { 
                        cmd_8[z] = cmd_8e[z] = 0;
                        _flag_D = 0x91;                       //  SMS "New Tel"
                        delay_ms (interval);
                        sms_out();                          //  SMS     
                        _flag_D = 0;
                        PORTB.2 = 0;
                        PORTB.3 = 0;                        // Led    
                        PORTD.5 = 0;
                        delay_ms (500);                     //  
                        #asm("sei")                         //   
                        return;                             //    
                        }
                    }
                }
            }
        }  
    }

//=====================================================================
void main(void)
{  
// Declare your local variables here
//-----------------------
// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/2048k
#pragma optsize-
WDTCR = (1<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0);   // OSC/2048k
WDTCR = (0<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (1<<WDP0);   // 1   2 

// WDTCR = (1<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0);   // OSC/1024k
// WDTCR = (0<<WDCE) | (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0);   // 1   1 

//-----------------------
// Input/Output Ports initialization
// Port B initialization
// Function: Bit7=In Bit6=In Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out 
DDRB=(0<<DDB7) | (0<<DDB6) | (1<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
// State: Bit7=T Bit6=T Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0 
PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Port C initialization
// Function: Bit6=In Bit5=In Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=In 
DDRC=(0<<DDC6) | (1<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);
// State: Bit6=T Bit5=T Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=T 
PORTC=(1<<PORTC6) | (0<<PORTC5) | (1<<PORTC4) | (1<<PORTC3) | (1<<PORTC2) | (1<<PORTC1) | (1<<PORTC0);

// Port D initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRD=(1<<DDD7) | (0<<DDD6) | (1<<DDD5) | (0<<DDD4) | (0<<DDD3) | (1<<DDD2) | (1<<DDD1) | (0<<DDD0);
// State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (1<<PORTD4) | (1<<PORTD3) | (1<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
//------------------------------
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=(0<<CS02) | (0<<CS01) | (0<<CS00);
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 3,906 kHz
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0<<AS2;
TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (0<<CS22) | (0<<CS21) | (0<<CS20);
TCNT2=0x00;
OCR2=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
//TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (0<<TOIE0);
// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;
//----------------------------------------
// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
//----------------------------------------
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
//UCSRA=0x00;
//UCSRB=0x98;  //0x08;                                      //        0x98; // ( )              
//UCSRB=(0<<RXEN)|( 1<<TXEN);                               //      USART 
//UCSRC=0x86;                                               //    AtMega8
//UBRRH=0x00;
//UBRRL=0x19;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600

UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;
//----------------------
// Analog Comparator initialization
// Analog Comparator: On
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
// Interrupt on Rising Output Edge
// Analog Comparator Input Capture by Timer/Counter 1: Off
//ACSR=(0<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
//SFIOR=(0<<ACME);
ACSR=(0<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
SFIOR=(0<<ACME);

// ADC initialization
// ADC disabled
ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);

//----------------------------------------
// SPI initialization
// SPI disabled
SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);
//----------------------------------------
// TWI initialization
// TWI disabled
TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);
//========================================
if (devices==0)
        {
        devices=w1_search(DS18B20_SEARCH_ROM_CMD,rom_code); //        1-Wire 
        ds18b20_init(0,-35,35,DS18B20_12BIT_RES);           //    12  
        delay_ms(500);
        }
_Start_telef();
#asm("cli")                                                 //  
i = 0;                                                      //   UART 
#asm("sei")                                                 //      
if (cmd_8e[0]!='+') Priviazka_tel();                        //      (     +)
for(z=0;z<13;z++)                                           //     EEProm
        { 
        cmd_8[z] = cmd_8e[z];                               //     EEProm  
        }                    
//----------------------------------------------
// Global enable interrupts
#asm("sei")

while (1)  //   
   {   unsigned char v, p1 =0;    
   #asm("wdr");                                             //   
//---------- ------------------------------------      
     if (PIND.3==0)
        { 
        for (z=0;z<60;z++)
            {
            if ((PIND.3==0)&&(z>50)) {Priviazka_tel(); z=61;};      //         2,5  
            
            delay_ms(50);
            }
        }                        
//-------------    -------------------  
            if (_tim > _tim_end) 
                {
                _tim=0; 
                _Temper();                                  //    DS18b20   60 
                }
            if (Temperat!=0)
                {
                if (Temperat==1)
                    {
                    PORTC.5 = 1;                            // Led   
                                                            // ----   -1   ----
                    v= _flag_D & 0x80;
                    if (v==0)  
                        { 
                        _flag_D = _flag_D | 0x80;           //  ( ) -    ( SMS "Temperat Holodno")
                        }               
                    }
                else  _flag_D = _flag_D & 0x7F;
                if (Temperat==2)
                    {
                    PORTC.5 = 1;                            // Led   
                                                            // ----  dsit 25   ----
                    v= _flag_D & 0x20;
                    if (v==0)  
                        { 
                        _flag_D = _flag_D | 0x20;           //  ( ) -    ( SMS "Temperat Jarko")
                        }               
                    }    
                else _flag_D = _flag_D & 0xDF;    
                } 
            else                                            // "" 
                {
                PORTC.5 = 0;
                }    
//-------------    ----------------------------
            if (Deact==5)                                   //     -   "DEACT"
                {              
                Deact=0;
                _Start_telef();                             //  Deact==5( )    GPS  
                }                                   
            if (Ring==4)                                    //  Ring==4( )   ()
                {
                Ring=0;                                     //   

                _Tel = 0;
                _Tel = AON_();                              //      
                Otboy();                                    //   ( ) 
                if (_Tel==1)                                //  ""     
                    {
                    PORTD.5 = 1;                            // Led     SMS "Temperat"
                    _flag_D = _flag_D | 0x40;               //  -     
                    }
                }   
//-------------  1  (  ) ----------------------------
            if (PINC.0==1)
                {                                           
                v= _flag_D & 0x01;                          // ""   
                if (v==0)                                   //    SMS                 
                    { 
                    PORTB.0 = 1;                            // Led=1    1
                    _flag_D = _flag_D | 0x01;               //  -   
                    } 
                }
            else                                            // "" 
                {
                _flag_D = _flag_D & 0xFE;                   //   D1=0
                PORTB.0 = 0;                                // Led=0    1
                }                         
                 
//-------------  2  (  ) ----------------------------
            if (PINC.1==1)
                {                                             
                v= _flag_D & 0x02;                          // "" 
                if (v==0)                                   //    SMS                 
                    {
                    PORTB.1 = 1;                            // Led=1    2
                    _flag_D = _flag_D | 0x02;               //  -      
                    }
                }
            else                                            // "" 
                {                                               
                _flag_D = _flag_D & 0xFD;                   //   D2=0
                PORTB.1 = 0;                                // Led=0    2
                }                                        
//-------------  3  ( =1 ) ----------------------------
            if (PINC.2==1)
                {                     
                v= _flag_D & 0x04;                          // "" 
                if (v==0)                                   //    SMS                 
                    {
                    PORTB.2 = 1;                            // Led=1    3
                    _flag_D = _flag_D | 0x04;               //  -   
                    }
                }
            else                                            // "" 
                {
                _flag_D = _flag_D & 0xFB;
                PORTB.2 = 0;                                // Led=0    3
                }                         
//-------------  4  ( =2 ) ----------------------------
            if (PINC.3==1)
                {                     
                v= _flag_D & 0x08;                          // "" 
                if (v==0)                                   //    SMS                 
                    {
                    PORTB.3 = 1;                            // Led=1    4  
                    _flag_D = _flag_D | 0x08;               //  -   
                    }
                }
            else                                            // "" 
                {
                _flag_D = _flag_D & 0xF7;
                PORTB.3 = 0;                                // Led=0    4 
                }                                    
//-------------  5  (  ) ----------------------------
            if (PINC.4==1)
                {                      
                v= _flag_D & 0x10;                          // "" 
                if (v==0)                                   //    SMS                 
                    {
                    PORTB.4 = 1;                            // Led=1    5
                    _flag_D = _flag_D | 0x10;               //  -   
                    }
                }
            else                                            // "" 
                {
                _flag_D = _flag_D & 0xEF;
                PORTB.4 = 0;                                // Led=0    5  
                }  
//--------------   -------------------------------                                      
     if (_flag_D>0) 
        { p1 = _flag_D & 0x3F; 
        if (p1>0) 
        if (siren==0) 
            { 
            siren=1;
            PORTD.7 = 1;
            _tim1 = 0;
            }
        else 
            {
            if(_tim1>_tim_end) PORTD.7 = 0;                 //  
            }
        if(_flag_D!=_flag)                                  //    -  
            {  
            _flag = _flag_D;                                //    ( )
            if (PIND.4!=0) Zvonok();                        //  = 1      
            else sms_out();                                 //   SMS  
            if (_flag_D&0x40) 
                {
                PORTD.5 = 0;
                _flag_D = _flag_D & 0xBf;                   //         (  SMS) 
                }
            PORTD.5 = 0;
            }
        }
    else  _flag = 0;  
    p1 = _flag_D & 0x3F; 
    if (p1==0)    
        {
        PORTD.7 = 0;                                        //        
        siren=0;                                            //  ,       (  )
        }
   }
}